/*
 *	imgctl_util.c
 *		̃t@C̊֐͎Rɓ]pĂč\܂B
 */

#include <windows.h>
#include "imgctl.h"

/* 摜t@CBMPt@Cɂ */
BOOL ToBMP(LPCSTR lpBmpFile, LPCSTR lpImageFile)
{
	BOOL bRes = FALSE;
	HDIB hDIB = NULL;

	hDIB = ToDIB(lpImageFile);
	if (hDIB != NULL)
	{
		bRes = DIBtoBMP(lpBmpFile, hDIB);
		DeleteDIB(hDIB);
	}

	return bRes;
}

/* 摜t@CJPEGt@Cɂ */
BOOL ToJPG(LPCSTR lpJpegFile, LPCSTR lpImageFile, int iQuality, BOOL bProgression)
{
	BOOL bRes = FALSE;
	HDIB hDIB = NULL;

	hDIB = ToDIB(lpImageFile);
	if (hDIB != NULL)
	{
		bRes = DIBtoJPG(lpJpegFile, hDIB, iQuality, bProgression);
		DeleteDIB(hDIB);
	}

	return bRes;
}

/* 摜t@CPNGt@Cɂ */
BOOL ToPNG(LPCSTR lpPngFile, LPCSTR lpImageFile, BOOL bInterlacing)
{
	BOOL bRes = FALSE;
	HDIB hDIB = NULL;

	hDIB = ToDIB(lpImageFile);
	if (hDIB != NULL)
	{
		bRes = DIBtoPNG(lpPngFile, hDIB, bInterlacing);
		DeleteDIB(hDIB);
	}

	return bRes;
}

/* 摜t@CGIFt@Cɂ */
BOOL ToGIF(LPCSTR lpGifFile, LPCSTR lpImageFile, BOOL bInterlacing)
{
	BOOL bRes = FALSE;
	HDIB hDIB = NULL;

	hDIB = ToDIB(lpImageFile);
	if (hDIB != NULL)
	{
		bRes = DIBtoGIF(lpGifFile, hDIB, bInterlacing);
		DeleteDIB(hDIB);
	}

	return bRes;
}

/* DIBf[^HBITMAP쐬 */
HBITMAP DIBtoOBJ(HDC hDC, HDIBC hDIB)
{
	LPCIMGDATA pimg;
	LPCBITMAPINFOHEADER pbmih;

	pimg = DataDIB(hDIB);
	if (!pimg) { return NULL; }
	pbmih = &pimg->pbmi->bmiHeader;

	return CreateDIBitmap(
		hDC, pbmih, CBM_INIT, pimg->pData, pimg->pbmi, DIB_RGB_COLORS);
}

/* DIBtoPNGex ̎g (PNGOPT\̂̐ݒ@) */
BOOL MyDIBtoPNG(HDIBC hDIB, LPCSTR lpPngFile, DWORD dwTrans)
{
	PNGOPT po;
	PALTRANS paltrns;

	/*
	 *	PNGOPT\̂̊eϐ́AdwFlagɃtO𗧂ĂȂ
	 *	LɂȂ܂(ݒ肵Ă܂)B
	 */
		po.dwFlag = 0;		/*  */

	/*
	 *	kx 0 ` 9 Őݒ肵܂B
	 *	ݒ肵Ȃꍇ̓ftHg̈kɂȂ܂B
	 *	ȂAJPEGƈႢA掿ɂ͉e܂B
	 */
		po.dwFlag |= POF_COMPLEVEL;	/* tO𗧂Ă */
		po.wCompLevel = 6;

	/*
	 *	tB^^Cvݒ肵܂B
	 *	ݒ肵Ȃꍇ̓tB^gpłB
	 *	ʏ͎gȂĂǂł傤B
	 */
		po.dwFlag |= POF_FILTER;	/* tO𗧂Ă */
		po.dwFilter = PO_FILTER_NONE | PO_FILTER_SUB;

	/*
	 *	K}␳lݒ肵܂B
	 *	ݒ肵Ȃꍇ͕Wlg܂B
	 *	ʏ͎gȂĂǂł傤B
	 */
		po.dwFlag |= POF_GAMMA;		/* tO𗧂Ă */
		po.dwGamma = GAMMA_WIN;

	/*
	 *	Fݒ肵܂B
	 *	ݒ肵Ȃꍇ͓F͂܂B
	 *	Wrbgȉ́Apbg݂DIBf[^̏ꍇA
	 *	F̐ݒɂ́AFEpbgEx ̂Rނ
	 *	ݒ@܂B
	 *	16rbgȏDIBf[^̏ꍇAFŵ݉\łB
	 */
		po.dwFlag |= POF_TRNSCOLOR;	/* tO𗧂Ă */
		switch (dwTrans)
		{
		/*
		 *	pbgŎw肷ꍇAclrTransɂ̓pbgԍ
		 *	w肵܂BȂAsȃpbgԍw肵ꍇA
		 *	ߏ͍s܂B
		 */
		case POF_TRNSPALETTE:
			po.dwFlag |= POF_TRNSPALETTE;	/* tO𗧂Ă */
			po.clrTrans = 25;				/* pbgԍݒ */
			break;

		/*
		 *	xŎw肷ꍇAclrTransɂ́AepbgƂ
		 *	xyя̗LZbgAPALTRANS\̂
		 *	AhXZbg܂B
		 *	x́A255 菬قǓxȂ܂B
		 *	0 Ȃ犮SA255 Ȃ犮SsłB
		 *	ȂAsSԂ̕\ɑΉĂuEÚA
		 *	_ł Netscape 6.x ȍ~ ݂̂łB
		 */
		case POF_TRNSALPHA:
			paltrns.trans[0] = 0;	/* Sɓ(wi) */
			paltrns.trans[1] = 255;	/* Sɕs(ʏ) */
			paltrns.trans[2] = 128;	/* x50 */
			paltrns.trans[3] = 64;	/* x75 */
			paltrns.dwNum = 4;		/* 0 ` 3 ̂S̏L */
			po.dwFlag |= POF_TRNSALPHA;		/* tO𗧂Ă */
			po.clrTrans = &paltrns;			/* \̂̃AhXݒ */
			break;

		/*
		 *	Fw̏ꍇAclrTransɂCOLORREFlZbg܂B
		 *	COLORREFlƂ 0x00BBGGRR ̌`ŕ\FłB
		 *	̒ĺARGB}NgƂłݒł܂B
		 *	RGB(, , ) ƂȂ܂B
		 *	ȂAtJ[PNG(pbg)̓ߕ\o
		 *	uEÚA_ł Netscape 6.x ȍ~ ݂̂łB
		 */
		default:
			po.clrTrans = RGB(128, 0, 128);	/* Zbg */
			break;
		}

	/*
	 *	wiFݒ肵܂B
	 *	ݒ肵Ȃꍇ͔wiF͂܂B
	 *	Wrbgȉ́Apbg݂DIBf[^̏ꍇA
	 *	ݒ@ɂ́AFEpbg ̂Qނ܂B
	 *	ݒ@͓F̏ꍇƓȂ̂ŏȗ܂B
	 *	wiFǂ́A摜r[ɂ܂B
	 *	ʏ͎gȂĂǂł傤B
	 */
		po.dwFlag |= POF_BACKCOLOR;	/* tO𗧂Ă */
		po.clrBack = RGB(255, 255, 255);	/* Zbg */

	/*
	 *	t@Cɖߍޕݒ肵܂()B
	 *	ݒ肵Ȃꍇ͉ߍ݂܂B
	 *	܂APOF_TEXTCOMP ZbgƁÄk
	 *	s܂B
	 *	ʏ͎gȂĂǂł傤B
	 */
		po.dwFlag |= POF_TEXT | POF_TEXTCOMP;	/* tO𗧂Ă */
		po.lpText = "VtgJISᕶ邩˂B";

	/*
	 *	POF_INTERLACING ZbgƃC^[[XPNGɂȂ܂B
	 *	uEUŌƁA摜WWƃ[h܂B
	 *	POF_TIME ZbgƍXVԂ摜ɕۑ܂B
	 *	ʏ͎gȂĂǂł傤B
	 */
		po.dwFlag |= POF_INTERLACING | POF_TIME;

	/*
	 *	ĉQ̕ϐɂ 0 ĂĉB
	 */
		po.dwReserved1 = 0;
		po.dwReserved2 = 0;

	return DIBtoPNGex(hDIB, lpPngFile, &po);
}
